package cz.muni.fi.pb162.test3;

/**
 * Toto rozhrani reprezentuje studenta. StudentImpl bude mit konstruktor
 * s dvema parametry, obsahujicimi jeho jmeno a prijmeni (ani jedno nesmi
 * byt null).
 */
public interface JavaStudent {

    /**
     * Tato metoda studenta informuje, ze mu byl pridelen nejaky ucitel.
     *
     * @throws IllegalStateException Pokud jiz student ucitele prideleneho ma.
     */
    public void accept();
    /**
     * Vrati informaci, zda ma student prideleneho ucitele
     *
     * @return true, pokud ma student prideleno ucitele
     */
    public boolean hasTeacher();
    
    /**
     * Vrati jmeno a prijmeni studenta.
     *
     * @return jmeno a prijmeni studenta.
     */
    public String toString();
    
    /**
     * Standardni metoda equals. Dva studenti jsou stejni, pokud maji 
     * stejne jmeno a prijmeni (bez ohledu na velikost pismen).
     *
     * @return true, pokud je argumentem student se stejnym jmenem
     */
    public boolean equals(Object o);
    
}
